<?php

namespace App\Commands;

use CodeIgniter\CLI\BaseCommand;
use CodeIgniter\CLI\CLI;
use Config\Clients;
use Config\Database;
use App\Models\VentasModel;
use App\Libraries\FacturacionElectronica;

class VerificarEstadoDTEs extends BaseCommand
{
    protected $group       = 'DET Manager';
    protected $name        = 'verificarEstadoDTEs';
    protected $description = 'Consulta el estado de los DTEs en la plataforma de FE y actualiza en el sistema de cliente.';
    protected $arguments   = ['isc' => 'Identificador del sistema de cliente'];
    protected $options     = ['--cant' => 'Cantidad maxima de DTE a tomar de la cola.'];

    public function run(array $params)
    {
        $isc = $params[0] ?? null;
        $cantDte = CLI::getOption('cant') ?? 5;

        if ($isc) {
            $client = new Clients();
            $dbgroup = $client->getDBGroup($isc);
            if ($dbgroup) 
            {
                $database = new Database();
                $dbConf = $database->getDatabaseConfig($dbgroup);
                $db = \Config\Database::connect($dbConf);

                $systemVersion = $client->getSystem($isc);
                $feStartDate = $client->getFeStartDate($isc);

                $ventasModel = new VentasModel($systemVersion, $db);

                $pendingSales = $ventasModel->getPendingSales($feStartDate, $cantDte);

                CLI::write(date('Y-m-d H:i:s').' Ventas pendiente encontradas: ' . count($pendingSales));

                if($pendingSales){
                    CLI::write(date('Y-m-d H:i:s').' Iniciando consultas de DTEs');
                    $feEnv = $client->getFeEnv($isc);
                    $facturacionElectronica = new FacturacionElectronica($feEnv);

                    foreach ($pendingSales as $sale) {
                        CLI::write(date('Y-m-d H:i:s').' Consultando dte: ' . $sale['dteCodGeneracion']);
                        //consultar DTE en API
                        $dte = $facturacionElectronica->consultarDTE($sale['dteCodGeneracion']);
                        if($dte)
                        {
                            $dteJson = isset($dte['json']) ? $dte['json'] : null;
                            if($dteJson)
                            {
                                $dteEstado = $dte['estado'];
                                $color = 'white';
                                switch($dteEstado){
                                    case 'PROCESADO':    $color = 'green'; break;
                                    case 'EN_PROCESO':   $color = 'yellow'; break;
                                    case 'FALLIDO':  	$color = 'red'; break;
                                }
                                CLI::write($dteEstado, $color);
                                if($dteEstado == 'PROCESADO' || $dteEstado == 'FALLIDO'){
                                     //actualizar estado
                                    $updated = $ventasModel->setDTEState($sale['id'], $dteEstado);
                                    if($updated)
                                    {
                                        CLI::write('ESTADO ACTUALIZADO', 'green');
                                    }
                                }
                                else
                                {
                                    CLI::error('No se pudo actualizar el estado del DTE: ' . $sale['dteNControl']);
                                }
                            }
                            else
                            {
                                CLI::error('DTE ' . $sale['dteNControl'] . ' no tiene formato esperado: [\'json\'] no presente');
                            }
                        }
                        else
                        {
                            CLI::error('No se pudo obtener el DTE: ' . $sale['dteNControl']);
                        }
                        
                    }
                }
                else
                {
                    CLI::write('No se encontraron ventas pendientes');
                }
            }
            else 
            {
                $isc = CLI::error('Identificador del sistema de cliente invalido');
            }
        }
        else
        {
            $isc = CLI::error('Identificador del sistema de cliente invalido');
        }
    }
}